#version 330

uniform vec3 BrickColor = vec3(1.f, 0.3f, 0.2f);
uniform vec3 MortarColor = vec3(0.85f, 0.86f, 0.84f);
uniform vec2 BrickSize = vec2(0.3f, 0.15f);
uniform vec2 BrickPct = vec2(0.9f, 0.85f);

in vec4 positionV;

out vec4 outputF;

//----------------------------------------------------------------
// TODO:
// 1) Create stripes: do nothing here :-)
// 2) Implement brick pattern without zigzap.
// 3) Implement zigzag pattern.
// 4) Apply smoothstep.
// 5) Use texture coordinates as the input, notice the difference.
//----------------------------------------------------------------

void main()
{
	vec2 t = positionV.xz / BrickSize;

	if (fract(t.y * 0.5) > 0.5)
		t.x += 0.5;

	t = fract(t);
	//t = step(t, BrickPct);
	//t = step(0.5, t);
	t = smoothstep(0.0f, 0.02f, t) - smoothstep(BrickPct, BrickPct + 0.02f, t);
	outputF = vec4(mix(MortarColor, BrickColor, t.x * t.y), 1.0);
}