#version 330

uniform vec3 BrickColor = vec3(1.f, 0.3f, 0.2f);
uniform vec3 MortarColor = vec3(0.85f, 0.86f, 0.84f);
uniform vec3 BrickSize = vec3(0.3f, 0.15f, 0.15f);
uniform vec3 BrickPct = vec3(0.9f, 0.85f, 0.85f);

in vec4 positionV;

out vec4 outputF;

//----------------------------------------------------------------
// TODO:
// 1) Use the y-axis instead of the z-axis
// 2) Offset the position a little in the y-axis to have the caps shaded.
// 3) Implement the pattern in the z-axis too.
//----------------------------------------------------------------

void main()
{
	vec3 t = positionV.xyz / BrickSize;
	t.y += 0.5;

	if (fract(t.y * 0.5) > 0.5)
		t.x += 0.5;
	if (fract(t.z * 0.5) > 0.5)
		t.x += 0.5;

	t = fract(t);
	t = smoothstep(0.0f, 0.02f, t) - smoothstep(BrickPct, BrickPct + 0.02f, t);
	outputF = vec4(mix(MortarColor, BrickColor, t.x * t.y * t.z), 1.0);
}